Index: /trunk/kernel/fs/vfs.h
===================================================================
--- /trunk/kernel/fs/vfs.h	(revision 656)
+++ /trunk/kernel/fs/vfs.h	(revision 657)
@@ -3,5 +3,5 @@
  *
  * Author  Mohamed Lamine Karaoui (2014,2015)
- *         Alain Greiner (2016,2017,2018)
+ *         Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -55,4 +55,5 @@
 struct vseg_s;
 struct page_s;
+struct ksock_s;
 
 /******************************************************************************************
@@ -72,13 +73,13 @@
  * The <extend> field is a pointer on the FS specific context extension. 
  * This extension is dynamically allocated by kernel_init in all clusters.
- * In each cluster, both this VFS context and the FS specific context are handled as
- * private by the local OS intance.
+ * In each cluster, the inum allocator can be accessed by any thread runing
+ * in any cluster, and is therefore protected by a remote_busylock. 
  *****************************************************************************************/
 
 typedef enum
 {
-	FS_TYPE_DEVFS = 0,
-	FS_TYPE_FATFS = 1,
-	FS_TYPE_RAMFS = 2,
+	FS_TYPE_RAMFS = 0,
+	FS_TYPE_DEVFS = 1,
+	FS_TYPE_FATFS = 2,
  
 	FS_TYPES_NR   = 3,
@@ -95,12 +96,11 @@
 typedef struct vfs_ctx_s
 {
-	vfs_fs_type_t  type;                     /*! File System type                        */
-	uint32_t	   attr;                     /*! global attributes for all files in FS   */
-	uint32_t       total_clusters;           /*! total number of clusters on device      */
-	uint32_t       cluster_size;             /*! cluster size on device (bytes)          */
-	xptr_t         vfs_root_xp;              /*! extended pointer on VFS root inode      */
-    busylock_t     lock;                     /*! lock protecting inum allocator          */
-    uint32_t       bitmap[BITMAP_SIZE(CONFIG_VFS_MAX_INODES)];  /* inum allocator        */
-    void         * extend;                   /*! FS specific context extension           */
+	vfs_fs_type_t      type;                 /*! File System type                        */
+	uint32_t           total_clusters;       /*! total number of clusters on device      */
+	uint32_t           cluster_size;         /*! cluster size on device (bytes)          */
+	xptr_t             vfs_root_xp;          /*! extended pointer on VFS root inode      */
+    remote_busylock_t  lock;                 /*! lock protecting inum allocator          */
+    uint32_t           bitmap[BITMAP_SIZE(CONFIG_VFS_MAX_INODES)];  /* inum allocator    */
+    void               * extend;             /*! FS specific context extension           */
 }
 vfs_ctx_t;
@@ -109,5 +109,5 @@
  * This structure define a VFS inode.
  * An inode can have several children dentries (if it is a directory), an can have several
- * parents dentries (if it hass several aliases links):
+ * parents dentries (if it has several aliases links):
  * - The "parents" field is the root of the xlist of parents dentries, and the "links"
  *   fiels define the number of aliases parent dentries. only a FILE inode can have
@@ -145,7 +145,7 @@
 typedef enum 
 {
-    INODE_ATTR_DIRTY   =     0x01,       /* modified versus the value on device          */ 
-    INODE_ATTR_INLOAD  =     0x04,       /* loading from device in progress              */
-    INODE_ATTR_NEW     =     0x08,       /* not saved on device yet                      */
+    INODE_ATTR_DIRTY   =     0x01,       /*! modified versus the value on device         */ 
+    INODE_ATTR_INLOAD  =     0x04,       /*! loading from device in progress             */
+    INODE_ATTR_NEW     =     0x08,       /*! not saved on device yet                     */
 }
 vfs_inode_attr_t;
@@ -193,5 +193,5 @@
 
 /******************************************************************************************
- Rpt* This structure defines a directory entry.
+ * This structure defines a directory entry.
  * A dentry contains the name of a remote file/dir, an extended pointer on the 
  * inode representing this file/dir, a local pointer on the inode representing 
@@ -225,10 +225,10 @@
 typedef enum
 {
-    FD_ATTR_READ_ENABLE    = 0x01,     /*! read access possible                         */
-    FD_ATTR_WRITE_ENABLE   = 0x02,     /*! write access possible                        */
-    FD_ATTR_APPEND         = 0x04,     /*! append on each write                         */
-    FD_ATTR_CLOSE_EXEC     = 0x08,     /*! close file on exec                           */
-    FD_ATTR_SYNC           = 0x10,     /*! synchronise FS on each write                 */
-    FD_ATTR_IS_DIR         = 0x20,     /*! this is a directory                          */
+    FD_ATTR_READ_ENABLE    = 0x01,     /*! read access possible                          */
+    FD_ATTR_WRITE_ENABLE   = 0x02,     /*! write access possible                         */
+    FD_ATTR_APPEND         = 0x04,     /*! append on each write                          */
+    FD_ATTR_CLOSE_EXEC     = 0x08,     /*! close file on exec                            */
+    FD_ATTR_SYNC           = 0x10,     /*! synchronise FS on each write                  */
+    FD_ATTR_IS_DIR         = 0x20,     /*! this is a directory                           */
 }
 vfs_file_attr_t;
@@ -237,5 +237,4 @@
 {
 	struct vfs_ctx_s      * ctx;        /*! local pointer on FS context.                 */
-	uint32_t                gc;         /*! generation counter                           */
 	vfs_file_attr_t         attr;       /*! file attributes bit vector (see above)       */
 	vfs_inode_type_t        type;       /*! same type as inode                           */
@@ -245,4 +244,5 @@
 	struct mapper_s       * mapper;     /*! associated file cache                        */
 	struct vfs_inode_s    * inode;      /*! local pointer on associated inode            */
+    struct socket_s       * socket;     /*! local pointer on associated socket           */
 	void                  * extend;     /*! FS specific extension                        */
 }
@@ -255,8 +255,10 @@
 
 /****************************************************************************************** 
- * This function initialise a (statically allocated) VFS context in local cluster. 
- ******************************************************************************************
+ * This function initialises a (statically allocated) VFS context in cluster identified
+ * by the <cxy> argument. 
+ * It is called by the kernel_init() function.
+ ******************************************************************************************
+ * @ cxy            : target cluster identifier.
  * @ fs_type        : file system type.
- * @ attr           : global attributes (for all files in FS.
  * @ total_clusters : total number of clusters on device.
  * @ cluster_size   : cluster size on device (bytes).
@@ -264,6 +266,6 @@
  * @ extend         : fs_type_specific extension.
  *****************************************************************************************/
-void vfs_ctx_init( vfs_fs_type_t   type,
-                   uint32_t        attr,
+void vfs_ctx_init( cxy_t           cxy,
+                   vfs_fs_type_t   type,
 	               uint32_t        total_clusters,
 	               uint32_t        cluster_size,
@@ -277,18 +279,18 @@
  * - the 16 LSB bits contains the local inode identifier  : lid
  ******************************************************************************************
- * @ ctx      : local pointer on file system context.
- * @ inum     : [ou] buffer for allocated inode identifier.
+ * @ ctx_xp   : [in]  extended pointer on file system context.
+ * @ inum     : [out] buffer for allocated inode identifier.
  * @ return 0 if success / return non-zero if error.
  *****************************************************************************************/
-error_t vfs_ctx_inum_alloc( vfs_ctx_t * ctx,
-                            uint32_t  * inum );
+error_t vfs_ctx_inum_alloc( xptr_t     ctx_xp,
+                            uint32_t * inum );
 
 /****************************************************************************************** 
  * This function release an inode identifier.                                  
  ******************************************************************************************
- * @ ctx      : local pointer on file system context.
- * @ inum     : released inode identifier.
- *****************************************************************************************/
-void vfs_ctx_inum_release( vfs_ctx_t * ctx,
+ * @ ctx_xp   : [in] extended pointer on file system context.
+ * @ inum     : [in] released inode identifier.
+ *****************************************************************************************/
+void vfs_ctx_inum_release( xptr_t      ctx_xp,
                            uint32_t    inum );
 
@@ -305,19 +307,21 @@
 
 /****************************************************************************************** 
- * This function allocates memory from local cluster for an inode descriptor and the 
- * associated mapper, and partially initialise this inode from arguments values.
+ * This function allocates memory in cluster identified by the <cxy> argument 
+ * for an inode descriptor and for the associated mapper, and partially initialise 
+ * this inode from arguments values.
  * It does NOT link it to the Inode Tree, as this is done by add_child_in_parent(). 
- * It must called by a local thread. Use the RPC_INODE_CREATE if client thread is remote.
- ******************************************************************************************
- * @ fs_type    : file system type.
- * @ inode_type : inode type.
- * @ attr       : inode attributes.
- * @ rights     : inode access rights.
- * @ uid        : user owner ID.
- * @ gid        : group owner ID.
+ * It can be called by any thread running in any cluster.
+ ******************************************************************************************
+ * @ cxy        : [in]  target cluster identifier
+ * @ fs_type    : [in]  file system type.
+ * @ attr       : [in]  inode attributes.
+ * @ rights     : [in]  inode access rights.
+ * @ uid        : [in]  user owner ID.
+ * @ gid        : [in]  group owner ID.
  * @ inode_xp   : [out] buffer for extended pointer on created inode.
- * @ return 0 if success / return ENOMEM or EINVAL if error.
- *****************************************************************************************/
-error_t vfs_inode_create( vfs_fs_type_t     fs_type,
+ * @ return 0 if success / return -1 if error.
+ *****************************************************************************************/
+error_t vfs_inode_create( cxy_t             cxy,
+                          vfs_fs_type_t     fs_type,
                           uint32_t          attr,
                           uint32_t          rights,
@@ -330,14 +334,14 @@
  * all memory allocated to the mapper (both mapper descriptor and radix tree).
  * The mapper should not contain any dirty page (should be synchronized before deletion).
- * It must be executed by a thread running in the cluster containing the inode.
- * Use the rpc_vfs_inode_destroy_client() function if required.
+ * It can be called by any thread running in any cluster.
  ****************************************************************************************** 
- * @ inode  : local pointer on inode descriptor.
- *****************************************************************************************/
-void vfs_inode_destroy( vfs_inode_t *  inode );  
+ * @ inode_xp  : extended pointer on inode descriptor.
+ *****************************************************************************************/
+void vfs_inode_destroy( xptr_t  inode_xp );  
 
 /****************************************************************************************** 
  * This function returns the <size> of a file/dir from a remote inode,
  * taking the remote_rwlock protecting <size> in READ_MODE.
+ * It can be called by any thread running in any cluster.
  *****************************************************************************************
  * @ inode_xp  : extended pointer on the remote inode.
@@ -350,4 +354,5 @@
  * It takes the rwlock protecting the file size in WRITE_MODE, and set the "size" field
  * when the current size is smaller than the requested <size> argument. 
+ * It can be called by any thread running in any cluster.
  *****************************************************************************************
  * @ inode_xp  : extended pointer on the remote inode.
@@ -358,6 +363,7 @@
 
 /****************************************************************************************** 
- * This function takes the main lock of a remote inode.
+ * This function takes the main lock of a remote inode identified by the <inode_xp>.
  * This lock protect all inode fields, including the children dentries.
+ * It can be called by any thread running in any cluster.
  *****************************************************************************************
  * @ inode_xp  : extended pointer on the remote inode.
@@ -366,6 +372,7 @@
 
 /****************************************************************************************** 
- * This function releases the main lock of a remote inode.
+ * This function releases the main lock of a remote inode identified by <inode_xp>.
  * This lock protect all inode fiels, including the children dentries.
+ * It can be called by any thread running in any cluster.
  *****************************************************************************************
  * @ inode_xp  : extended pointer on the remote inode.
@@ -377,4 +384,5 @@
  * argument to a local buffer identified by the <name> argument.
  * The local buffer size must be at least CONFIG_VFS_MAX_NAME_LENGTH. 
+ * It can be called by any thread running in any cluster.
  ******************************************************************************************
  * @ inode_xp  : extended pointer on the remote inode.
@@ -385,19 +393,19 @@
 
 /******************************************************************************************
- * This function accesses successively all pages of a file identified by the <inode>,
+ * This function accesses successively all pages of a file identified by the <inode_xp>,
  * argument, to force misses, and load all pages into mapper.
  * The target inode can be a directory or a file, but this function is mainly used 
  * to prefetch a complete directory to the mapper.
- * It must be executed by a thread running in the cluster containing the inode.
  * This function does NOT take any lock.
- ******************************************************************************************
- * @ inode  : local pointer on inode.
+ * It can be called by any thread running in any cluster.
+ ******************************************************************************************
+ * @ inode_xp  : extended pointer on inode.
  * @ return 0 if success / return -1 if device access failure.
  *****************************************************************************************/
-error_t vfs_inode_load_all_pages( vfs_inode_t * inode );
-
-/****************************************************************************************** 
- * This debug function display the curren state of an inode descriptor identified by
- * the <inode_xp> argument.
+error_t vfs_inode_load_all_pages( xptr_t inode_xp );
+
+/****************************************************************************************** 
+ * This debug function display the curren state of an inode descriptor.
+ * It can be called by any thread running in any cluster.
  *****************************************************************************************/
 void vfs_inode_display( xptr_t inode_xp );
@@ -408,8 +416,10 @@
 
 /****************************************************************************************** 
- * This function allocates memory from local cluster for a dentry descriptor, 
- * initialises it from  arguments values, and returns the extended pointer on dentry.
- * It must called by a local thread. Use the RPC_DENTRY_CREATE if client thread is remote.
- ******************************************************************************************
+ * This function allocates memory in cluster identified by the <cxy> argument
+ * for a dentry descriptor, initialises it from  arguments values, and returns 
+ * in <dentry_xp> the extended pointer on dentry.
+ * It can be called by any thread running in any cluster.
+ ******************************************************************************************
+ * @ cxy        : [in]  target cluster identifier
  * @ fs_type    : [in]  file system type.
  * @ name       : [in]  directory entry file/dir name.
@@ -417,5 +427,6 @@
  * @ return 0 if success / return ENOMEM or EINVAL if error.
  *****************************************************************************************/
-error_t vfs_dentry_create( vfs_fs_type_t   fs_type,
+error_t vfs_dentry_create( cxy_t           cxy,
+                           vfs_fs_type_t   fs_type,
                            char          * name,
                            xptr_t        * dentry_xp );
@@ -424,10 +435,9 @@
  * This function removes the dentry from the parent inode xhtab, and releases the memory
  * allocated to the dentry descriptor.
- * It must be executed by a thread running in the cluster containing the dentry.
- * Use the RPC_DENTRY_DESTROY if required.
+ * It can be called by any thread running in any cluster.
  ****************************************************************************************** 
- * @ dentry  : [in] local pointer on dentry descriptor.
- *****************************************************************************************/
-void vfs_dentry_destroy( vfs_dentry_t *  dentry );  
+ * @ dentry_xp  : [in] extended pointer on dentry descriptor.
+ *****************************************************************************************/
+void vfs_dentry_destroy( xptr_t  dentry_xp );  
 
 
@@ -437,30 +447,31 @@
 
 /****************************************************************************************** 
- * This function allocates memory and initializes a new local file descriptor.
- * It must be executed in the cluster containing the inode.
- * If the client thread is not running in the owner cluster, it must use the
- * rpc_vfs_file_create_client() function.
+ * This function allocates memory and initializes a new file descriptor in the
+ * cluster defined by the <inode_xp> argument.
+ * It can be called by any thread running in any cluster.
  ****************************************************************************************** 
- * @ inode    : local pointer on associated inode.
- * @ attr     : file descriptor attributes.
- * @ file_xp  : [out] buffer for extended pointer on created file descriptor.
+ * @ inode_xp  : [in]  extended pointer on associated inode.
+ * @ attr      : [in]  file descriptor attributes.
+ * @ file_xp   : [out] buffer for extended pointer on created file descriptor.
  * @ return 0 if success / return ENOMEM if error.
  *****************************************************************************************/
-error_t vfs_file_create( vfs_inode_t * inode,
+error_t vfs_file_create( xptr_t        inode_xp,
                          uint32_t      attr,
                          xptr_t      * file_xp );  
 
 /****************************************************************************************** 
- * This function releases memory allocated to a local file descriptor.
- * It must be executed by a thread running in the cluster containing the inode,
- * and the file refcount must be zero. Use the RPC_VFS_FILE_DESTROY if required.
+ * This function releases memory allocated to file descriptor identified
+ * by the <file_xp> argument.
+ * It can be called by any thread running in any cluster.
  ****************************************************************************************** 
- * @ file  : local pointer on file descriptor.
- *****************************************************************************************/
-void vfs_file_destroy( vfs_file_t *  file );  
+ * @ file_xp  : [in] extended pointer on file descriptor.
+ *****************************************************************************************/
+void vfs_file_destroy( xptr_t  file_xp );  
 
 /****************************************************************************************** 
  * These functions increment (resp. decrement) the count field in a remote file
  * descriptor, using a remote_atomic access. 
+ *****************************************************************************************
+ * @ file_xp  : extended pointer on file descriptor.
  *****************************************************************************************/
 void vfs_file_count_up  ( xptr_t   file_xp );
@@ -472,7 +483,7 @@
  * The local buffer size must be at least CONFIG_VFS_MAX_NAME_LENGTH. 
  *****************************************************************************************
- * @ file_xp  : extended pointer on the remote inode.
- * @ name     : local buffer pointer.
- *****************************************************************************************/
+ * @ ionde_xp  : [in] extended pointer on the remote inode.
+ * @ name      : [out] local string.
+ ***************************************************************************************/
 void vfs_file_get_name( xptr_t inode_xp,
                         char * name );
@@ -596,29 +607,7 @@
 
 /******************************************************************************************
- * This function is called by the vfs_lookup() function when a new (dentry/inode) must
- * be created from scratch and introduced in both the parent mapper and the IOC device.
- * The dentry and inode descriptors must have been previously created by the caller.
- * 1. It allocates one cluster from the relevant FS, updates the FAT mapper,
- *    and synchronously update the IOC device).
- * 2. It set the "size", and "extend" fields in child inode descriptor.
- *    The size is 4096 for a directory, the size is 0 for a file.
- * 3. It updates the parent directory mapper to introduce the new child,
- *    and synchronously update the IOC device.
- * 4. It set the "extend" field in dentry descriptor.
- * It can be called by a thread running in any cluster.
- ******************************************************************************************
- * @ parent_xp   : extended pointer on parent inode descriptor.
- * @ dentry_xp   : extended pointer on new dentry descriptor.
- * @ child_xp    : extended pointer on child inode descriptor.
- * @ return 0 if success / -1 if failure.
- *****************************************************************************************/
-error_t vfs_new_dentry_init( xptr_t   parent_xp,
-                             xptr_t   dentry_xp,
-                             xptr_t   child_xp );
-
-/******************************************************************************************
- * This function creates in the directory identified by the <child_xp> argument, 
+ * This function creates in the directory identified by the <child_inode_xp> argument, 
  * the two special dentries <.> and <..>. The parent directory inode is defined
- * by the <parent_xp> argument. The two dentries are introduced in the Inode Tree.
+ * by the <parent_inode_xp> argument. The two dentries are introduced in the Inode Tree.
  * They are also introduced in the child directory mapper, and the IOC device is updated.
  * This function is called by all functions creating a brand new directory : vfs_mkdir(),
@@ -629,6 +618,6 @@
  * @ return 0 if success / -1 if failure.
  *****************************************************************************************/
-error_t vfs_add_special_dentries( xptr_t  child_xp,
-                                  xptr_t  parent_xp );
+error_t vfs_add_special_dentries( xptr_t  child_inode_xp,
+                                  xptr_t  parent_inode_xp );
 
 /******************************************************************************************
@@ -893,35 +882,16 @@
 
 /******************************************************************************************
- *        These functions define the VFS "FS" API to a specific File System
- *****************************************************************************************/
-
-/******************************************************************************************
- * This function makes the I/O operation to move one page identified by the <page_xp>
- * argument to/from the IOC device from/to the mapper, as defined by the <cmd_type>.
+ *      These functions define the VFS "FS" API to access a specific File System
+ *****************************************************************************************/
+
+/******************************************************************************************
+ * This function introduces in a directory mapper identified by the <parent_inode_xp>
+ * argument, a new entry identified by the <dentry_ptr> argument. 
  * Depending on the file system type, it calls the proper, FS specific function.
- * It is used in case of MISS on the mapper (read), or when a dirty page in the mapper
- * must be updated in the File System (write).
- * The mapper pointer, and the page index in file are obtained from the page descriptor.
- * It can be executed by any thread running in any cluster.
- * This function does NOT take any lock.
- ******************************************************************************************
- * @ page_xp   : extended pointer on page descriptor (for mapper and page_id).
- * @ cmd_type  : IOC_READ / IOC_WRITE / IOC_SYNC_READ / IOC_SYNC_WRITE
- * @ returns 0 if success / return -1 if device access failure.
- *****************************************************************************************/
-error_t vfs_fs_move_page( xptr_t      page_xp,
-                          cmd_type_t  cmd_type );
-
-/******************************************************************************************
- * This function updates the mapper associated to a directory inode identified by the 
- * <parent> argument, to add a new entry identified by the <dentry> argument. 
- * The directory inode descriptor and the dentry descriptor are in the same cluster.
- * Depending on the file system type, it calls the proper, FS specific function.
- * It also updates the dentry descriptor and/or the inode descriptor extensions
- * as required by the specific file system type.
+ * All informations related to the new directory must be contained in the dentry 
+ * descriptor, or in the associated child inode descriptor.
+ * The dentry descriptor "extend" field is updated as required by the specific FS. 
  * Finally, it synchronously updates the parent directory on IOC device.
- *
- * It must be executed by a thread running in the cluster containing the parent directory.
- * It can be the RPC_VFS_FS_ADD_DENTRY. This function does NOT take any lock.
+ * This function can be called by any thread running in any cluster.
  ******************************************************************************************
  * @ parent  : local pointer on parent (directory) inode.
